import { ITagData } from 'vscode-html-languageservice';
import { Location, Range } from 'vscode-languageserver';
import { Metadata, ClassMember } from './decorators';
import { AttributeInfo } from '@salesforce/lightning-lsp-common/lib/indexer/attributeInfo';
export declare type TagAttrs = {
    file?: string;
    metadata?: Metadata;
    updatedAt?: Date;
};
export default class Tag implements ITagData {
    file: string;
    metadata: Metadata;
    updatedAt: Date;
    private _allAttributes;
    private _properties;
    private _methods;
    constructor(attributes: TagAttrs);
    get description(): string;
    get name(): string;
    get auraName(): string;
    get lwcName(): string;
    get lwcTypingsName(): string;
    get attributes(): AttributeInfo[];
    attribute(name: string): AttributeInfo | null;
    get documentation(): string;
    get attributeDocs(): string | null;
    get classMembers(): ClassMember[];
    classMember(name: string): ClassMember | null;
    classMemberLocation(name: string): Location | null;
    get methodDocs(): string | null;
    get uri(): string;
    get allAttributes(): {
        publicAttributes: AttributeInfo[];
        privateAttributes: AttributeInfo[];
    };
    get publicAttributes(): AttributeInfo[];
    get privateAttributes(): AttributeInfo[];
    get properties(): ClassMember[];
    get methods(): ClassMember[];
    get apiMethods(): ClassMember[];
    get range(): Range;
    get location(): Location;
    get allLocations(): Location[];
    updateMetadata(meta: any): void;
    static fromFile(file: string, updatedAt?: Date): Promise<Tag> | null;
}
//# sourceMappingURL=tag.d.ts.map